#!/usr/bin/python

import os
import gtk
import pygtk

class DirView:
    def __init__(self):
        self.treeView = gtk.TreeView()
        self.treeView.set_headers_visible(False)
        self.tree_selection = self.treeView.get_selection()
        self.tree_selection.set_mode(gtk.SELECTION_SINGLE)
        self.tree_selection.set_select_function(self.select_dir)

        self.column = gtk.TreeViewColumn()

        self.scrolledwindow = gtk.ScrolledWindow()
        self.scrolledwindow.add(self.treeView)

    def buid_dir_tree(self, path):
        store = gtk.TreeStore(str, str)
        parents = {}
        parents[path] = store.append(None, [os.path.split(os.path.dirname(path))[1], gtk.STOCK_DIRECTORY])
        for dir, dirs, files in os.walk(path):
            for subdir in dirs:
                parents[os.path.join(dir, subdir)] = store.append(parents.get(dir, None), [subdir, gtk.STOCK_DIRECTORY])
        return store

    def select_dir(self, selection):
        print selection
        self.selected_dir = str(selection)
        return True

    def get_widget(self):
        return self.scrolledwindow

    def change_dir(self, path):
        self.root_dir = path
        store = self.buid_dir_tree(path)

        self.treeView.set_model(self.buid_dir_tree(path))

        self.treeView.remove_column(self.column)
        #del self.column
        self.column = gtk.TreeViewColumn()

        cellpb = gtk.CellRendererPixbuf()
        self.column.pack_start(cellpb, False)
        self.column.add_attribute(cellpb, "stock-id", 1)

        cell = gtk.CellRendererText()
        self.column.pack_start(cell, False)
        self.column.add_attribute(cell, "text", 0)

        #self.column.set_sort_order(gtk.SORT_ASCENDING)
        self.treeView.append_column(self.column)

    def get_selected_dir(self):
        return self.selected_dir
        


if __name__ == '__main__':
    window = gtk.Window()
    view = DirView()
    view.change_dir('/home/ben/')
    window.add(view.get_widget())
    window.show_all()
    gtk.main()
