#!/usr/bin/python

import os
import gtk
import pygtk

class IconView:
    def __init__(self):
        self.store = gtk.ListStore(gtk.gdk.Pixbuf)
        self.icons = gtk.IconView(self.store)
        self.icons.set_pixbuf_column(0)

        self.scrolledwindow = gtk.ScrolledWindow()
        self.scrolledwindow.add(self.icons)

    def scale(self, w, h, x, y, maximum=True):
        nw = y * w / h
        nh = x * h / w
        if maximum ^ (nw >= x):
            return nw or 1, y
        return x, nh or 1

    def get_widget(self):
        return self.scrolledwindow

    def change_path(self, path):
        self.directory = path
        self.photos = os.listdir(path)
        self.photos.sort()

        self.store.clear()

        for phot in self.photos:
            pixbuf = gtk.gdk.pixbuf_new_from_file(os.path.join(self.directory, phot))
            x, y = self.scale(pixbuf.get_width(), pixbuf.get_height(), 128, 128)
            pixbuf = pixbuf.scale_simple(x, y, gtk.gdk.INTERP_BILINEAR)
            self.store.append((pixbuf, ))


if __name__ == '__main__':
    window = gtk.Window()

    photo = IconView()
    photo.change_path('/home/ben/Pictures/Testimages/')
    #photo.change_path('/usr/share/icons/hicolor/16x16/apps/')

    window.add(photo.get_widget())
    window.show_all()
    gtk.main()
