#!/usr/bin/python

import os
import gtk
import pygtk

class ImageView:
    def __init__(self):
        #self.aspect_frame = gtk.Frame(None)

        self.scrolledwindow = gtk.ScrolledWindow()
        self.scrolledwindow.set_policy(gtk.POLICY_NEVER,gtk.POLICY_NEVER)

        self.image = gtk.Image()
        self.pixbuf = self.image.get_pixbuf()
        self.image.connect('expose-event', self.on_image_resize, self.scrolledwindow)

        self.scrolledwindow.add(self.image)

        #self.aspect_frame.add(self.scrolledwindow)

    def on_image_resize(self, widget, event, window):
        allocation = self.scrolledwindow.get_allocation()

        x, y = self.scale(self.pixbuf.get_width(), self.pixbuf.get_height(), allocation.width, allocation.height)
        pixbuf = self.pixbuf.scale_simple(x, y, gtk.gdk.INTERP_BILINEAR)
        self.image.set_from_pixbuf(pixbuf)

    def change_path(self, path):
        self.directory = path
        self.photos = os.listdir(path)
        self.photos.sort()
        self.position = 0
        self.change_photo(None, 0)

    def change_photo(self, button, direction):
        self.position  = (self.position + direction) % len(self.photos)

        self.image.set_from_file(os.path.join(self.directory, self.photos[self.position]))
        self.pixbuf = self.image.get_pixbuf()
        #ratio = self.find_ratio(self.image.get_allocation().width, self.image.get_allocation().height)
        #self.aspect_frame.set(0.5, 0.5, ratio, False)

    def get_widget(self):
        return self.scrolledwindow#self.aspect_frame

    def scale(self, w, h, x, y, maximum=True):
        nw = y * w / h
        nh = x * h / w
        if maximum ^ (nw >= x):
            return nw or 1, y
        return x, nh or 1

    def find_ratio(self, a, b):
        if b == 0:
            return a
        return self.find_ratio(b, a % b)



if __name__ == '__main__':
    window = gtk.Window()

    photo = ImageView()
    photo.change_path('/home/ben/Pictures/Testimages')

    window.add(photo.get_widget())
    window.show_all()
    gtk.main()
