#!/usr/bin/python

import os
import gtk
import pygtk

from ImageView import *
from DirView import *
from IconView import *

class PhotoViewer:
    def __init__(self):
        window = gtk.Window()
        window.set_default_size(800, 640)
        window.set_border_width(10)
        window.set_title("Photo Viewer")
        window.connect("destroy", self.destroy)

        hbx = gtk.VBox()

        self.notebook = gtk.Notebook()
        self.notebook.set_show_tabs(False)
        self.notebook.set_show_border(False)
        window.add(hbx)

        toolbar = gtk.Toolbar()
        toolbar.set_style(gtk.TOOLBAR_ICONS)

        newtb = gtk.ToolButton(gtk.STOCK_NEW)
        newtb.connect("clicked", self.change_page)
        sep = gtk.SeparatorToolItem()
        quittb = gtk.ToolButton(gtk.STOCK_QUIT)

        toolbar.insert(newtb, 0)
        toolbar.insert(sep, 1)
        toolbar.insert(quittb, 2)
        
        quittb.connect("clicked", gtk.main_quit)

        hbx.pack_start(toolbar, False, False)
        hbx.add(self.notebook)

        box = gtk.HPaned() #gtk.HBox()
        self.notebook.append_page(box)
        

        view = DirView()
        view.change_dir('/home/ben/')

        vbox = gtk.VBox()
        vbox.set_spacing(5)
        hbox = gtk.HBox(True)
        hbox.set_spacing(5)
 
        photo = ImageView()
        photo.change_path('/home/ben/Pictures/')

        previous = gtk.Button(None, gtk.STOCK_GO_BACK)
        previous.connect_after("clicked", photo.change_photo, -1)
        #previous.set_size_request(128, 32)
        hbox.pack_start(previous)

        next = gtk.Button(None, gtk.STOCK_GO_FORWARD)
        next.connect_after("clicked", photo.change_photo, 1)
        #previous.set_size_request(128, 32)
        hbox.pack_start(next)

        icons = IconView()
        icons.change_path('/home/ben/Pictures/')

        box.add(view.get_widget())
        box.add(icons.get_widget())
        vbox.pack_start(hbox, False, False)
        vbox.add(photo.get_widget())

        self.notebook.append_page(vbox)
        self.notepage = 0

        window.show_all()

    def destroy(self, widget):
        gtk.main_quit()

    def change_page(self, widget):
        if self.notepage == 1:
            self.notepage = 0
        else:
            self.notepage = 1
        self.notebook.set_current_page(self.notepage)


def main():
    PhotoViewer()
    gtk.main()

if __name__ == '__main__':
    main()
