#!/usr/bin/python

import gtk
import os
import sys


class MyApp:
    def __init__(self):
        window = gtk.Window()
        window.set_title("Photo Viewer")
        window.connect("destroy", self.destroy)

        hbox1 = gtk.HBox()
        window.add(hbox1)

        vbox = gtk.VBox()
        hbox1.add(vbox)

        hbox = gtk.HBox()#homogeneous=True)
        vbox.add(hbox)

        self.directory = "/home/ben/Pictures"

        store = self.buid_dir_tree(self.directory)

        treeView = gtk.TreeView()
        treeView.set_model(store)  
        column = gtk.TreeViewColumn("Directories")
        treeView.append_column(column) 
        cell = gtk.CellRendererText()
        column.pack_start(cell, False)
        column.add_attribute(cell, "text", 0)

        tree_selection = treeView.get_selection()
        tree_selection.set_mode(gtk.SELECTION_SINGLE)
        tree_selection.set_select_function(self.select_dir)


        scrolledwindow = gtk.ScrolledWindow()
        hbox1.add(scrolledwindow)
        scrolledwindow.add(treeView)

        self.change_dir(self.directory)

        self.photo = gtk.Image()
        vbox.add(self.photo)
        self.photo.set_from_file(os.path.join(self.directory, self.photos[0]))

        previous = gtk.Button(None, gtk.STOCK_GO_BACK)
        previous.connect_after("clicked", self.change_photo, -1)
        #previous.set_size_request(-1, 10)
        hbox.add(previous)

        next = gtk.Button(None, gtk.STOCK_GO_FORWARD)
        next.connect_after("clicked", self.change_photo, 1)
        hbox.add(next)

        window.show_all()

    def buid_dir_tree(self, path):
        store = gtk.TreeStore(str)
        parents = {}
        for dir, dirs, files in os.walk(path):
            for subdir in dirs:
                parents[os.path.join(dir, subdir)] = store.append(parents.get(dir, None), [subdir])
        return store

    def change_dir(self, dir):
        self.photos = os.listdir(dir)
        self.photos.sort()
        self.position = 0

    def select_dir(self, selection):
        print selection
        return True

    def change_photo(self, button, direction):
        self.position  = (self.position + direction) % len(self.photos)
        self.photo.set_from_file(os.path.join(self.directory, self.photos[self.position]))

    def destroy(self):
        gtk.main_quit()
        


def main():
    MyApp()
    gtk.main()

if __name__ == '__main__':
    main()
