import gtk

class ScaleImage:
    def __init__(self):

        window = gtk.Window(gtk.WINDOW_TOPLEVEL)

        image = gtk.Image()
        image.set_from_file('/home/ben/my_test_image.jpg')
        self.pixbuf = image.get_pixbuf()
        image.connect('expose-event', self.on_image_resize, window)    
        #window.connect('expose_event', self.on_image_resize, window)

        box = gtk.ScrolledWindow()
        box.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        box.add(image) #_with_viewport(image)

        window.add(box)
        window.set_size_request(300, 300)
        window.show_all()       

        self.temp_height = 300
        self.temp_width = 300

    def on_image_resize(self, widget, event, window):
        allocation = widget.get_allocation()
        if self.temp_height != allocation.height or self.temp_width != allocation.width:
            allocation.width, allocation.height = self.scale(self.temp_width, self.temp_height, allocation.width, allocation.height)
            self.temp_height = allocation.height
            self.temp_width = allocation.width
            pixbuf = self.pixbuf.scale_simple(allocation.width, allocation.height, gtk.gdk.INTERP_BILINEAR)
            widget.set_from_pixbuf(pixbuf)

    def scale(self, w, h, x, y, maximum=True):
        nw = y * w / h
        nh = x * h / w
        if maximum ^ (nw >= x):
            return nw or 1, y
        return x, nh or 1

    def close_application(self, widget, event, data=None):
        gtk.main_quit()
        return False

if __name__ == "__main__":
    r = ScaleImage()
    gtk.main()

