#!/usr/bin/env python

import pygtk
import gtk

class WindowImageTest:
    def __init__(self):
        window = gtk.Window(gtk.WINDOW_TOPLEVEL);
        window.set_title("Frame")
        window.connect("destroy", lambda x: gtk.main_quit())
        window.set_border_width(10)

        aspect_frame = gtk.AspectFrame("2x1", # label
                                       0.5, # center x
                                       0.5, # center y
                                       obey_child = True) # ignore child's aspect

        window.add(aspect_frame)
        aspect_frame.show()

        image = gtk.Image()
        image.set_from_file('/home/ben/my_test_image.jpg')
        self.pixbuf = image.get_pixbuf()
        image.connect('expose-event', self.on_image_resize, aspect_frame)
        image.show()


        aspect_frame.add(image)
        window.show()


    def scale(self, w, h, x, y, maximum=True):
        nw = y * w / h
        nh = x * h / w
        if maximum ^ (nw >= x):
            return nw or 1, y
        return x, nh or 1


def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    WindowImageTest()
    main()
